<?php 

if ($forum_id != 0 && !isset($forum['id'])) {
	return ; 
}

/**
* Создание раздела
*/ 

if ($action == 'create' && isset($_POST['title'])) {
	if (strlen2($_POST['title']) < 2) {
		add_error(__p('Слишком короткое название', DS_FORUM)); 
	}
	
	if (strlen2($_POST['title']) > 128) {
		add_error(__p('Слишком длинное название', DS_FORUM)); 
	}
	
	if (!is_errors()) {
		$slug = gen_forum_slug($_POST['title']); 

		$path = '/'; 
		if ($forum_id) {
			$parent = get_forum($forum_id); 

			if ($parent['path'] != '/') {
				$path = $parent['path'] . $parent['slug'] . '/'; 
			} else {
				$path = '/' . $parent['slug'] . '/'; 
			}
		}

		db::insert('forum', array(
			'title' => $_POST['title'], 
			'description' => $_POST['msg'], 
			'type' => $_POST['type'], 
			'parent_id' => $forum_id, 
			'slug' => $slug, 
			'path' => $path, 
		)); 
		
		$_SESSION['message'] = __p('Раздел успешно создан', DS_FORUM); 
		ds_redirect(get_admin_url($plug, array(
            'forum_id' => $forum_id, 
        ))); 
	}
}

/**
* Редактирование раздела
*/ 

if ($action == 'edit' && isset($_POST['title'])) {
	if (strlen2($_POST['title']) < 2) {
		add_error(__p('Слишком короткое название', DS_FORUM)); 
	}
	
	if (strlen2($_POST['title']) > 128) {
		add_error(__p('Слишком длинное название', DS_FORUM)); 
	}
	
	if (!is_errors()) {
		$slug = gen_forum_slug($_POST['slug'], $forum_id); 

		db::update('forum', array(
			'title' => $_POST['title'], 
			'description' => $_POST['msg'], 
			'type' => $_POST['type'], 
			'slug' => $slug, 
		), array(
			'id' => $forum_id, 
		)); 
		
		$_SESSION['message'] = __p('Изменения успешно приняты', DS_FORUM); 
		ds_redirect(get_admin_url($plug, array(
            'forum_id' => $forum['parent_id'], 
        ))); 
	}
}

/**
* Удаление раздела
*/ 

if ($action == 'remove') {
	if (is_confirmed_valid('confirm', $forum['id'])) {

		$childs = get_forum_childs($forum['id']); 
		$forum_ids = array($forum['id']); 

		foreach($childs AS $child) {
			$forum_ids[] = $child['id']; 
		}

		$topics = db::select("SELECT * FROM forum_topics WHERE forum_id IN(" . join(',', $forum_ids) . ")"); 
		foreach($topics AS $t) {
			db::query("DELETE FROM forum_comments WHERE object_id = '" . $t['id'] . "'"); 
			db::query("DELETE FROM forum_topics WHERE id = '" . $t['id'] . "'"); 
		}

		db::query("DELETE FROM forum WHERE id IN(" . join(',', $forum_ids) . ")"); 

		$_SESSION['message'] = __p('Раздел успешно удален', DS_FORUM); 
		ds_redirect(get_admin_url($plug, array(
            'forum_id' => $forum['parent_id'], 
        ))); 
	} else {

	}
}