<?php 

class DB_Forum_Topics
{
	public $args = array(); 
	public $paged = 1; 
	public $pages = 0; 
	public $total = 0; 
	public $request = ''; 
	public $items; 
	private $config; 

	public function __construct($args = array()) 
	{
		$set = get_settings(); 

		if (!isset($args['p_str'])) {
			$args['p_str'] = $set['p_str']; 
		}

		if (!isset($args['paged'])) {
			$args['paged'] = get_paged(); 
		}

		if (!isset($args['order'])) {
			$args['order'] = 'DESC'; 
		}

		if (!isset($args['orderby'])) {
			$args['orderby'] = 'forum_topics.id'; 
		}

		if (!isset($args['last'])) {
			$args['last'] = 0; 
		}

		if (!isset($args['forum_id'])) {
			$args['forum_id'] = 0; 
		}

		if (!isset($args['forum_in'])) {
			$args['forum_in'] = array(); 
		}

		if (!isset($args['forum_not_in'])) {
			$args['forum_not_in'] = array(); 
		}

		$this->paged = $args['paged']; 
		$this->args = array_merge($this->args, $args); 
		$this->query($this->args); 
	}

	public function query($args) 
	{
		if (!isset($args['status'])) {
			$args['status'] = 'open'; 
		}

		$SQLConst['%select%'] = "*"; 
		$SQLConst['%join%'] = "";

		$where = array(); 

		if ($args['forum_id'] > 0) {
			$where[] = "`forum_id` = '" . $args['forum_id'] . "'"; 
		}

		if (is_array($args['forum_in']) && count($args['forum_in']) > 0) {
			$where[] = "`forum_in` IN('" . join(',', $args['forum_in']) . "')"; 
		}

		if (is_array($args['forum_not_in']) && count($args['forum_not_in']) > 0) {
			$where[] = "`forum_not_in` NOT IN('" . join(',', $args['forum_not_in']) . "')"; 
		}

		if ($args['status'] != 'all') {
			$where[] = "`status` = '" . $args['status'] . "'"; 
		}

		if ($args['last'] > 0) {
			$where[] = "`id` > '" . $args['last'] . "'";
		}
		
		if (isset($args['where'])) {
			if (is_array($args['where'])) { 
				$where[] = db::get_construct_query_where('forum_topics', $args['where'], ''); 
			} elseif (is_string($args['where'])) {
				$where[] = $args['where']; 
			}
		}
		
		$SQLConst['%where%'] = ($where ? 'AND ' . implode(' AND ', $where) : ''); 
		$SQLConst['%order%'] = "ORDER BY " . $args['orderby'] . " " . $args['order']; 
		
		$SQLConst['%limit%'] = ''; 
		if ($args['p_str'] != '-1') {
			$start  = $args['p_str'] * $args['paged'] - $args['p_str'];
			$SQLConst['%limit%'] = "LIMIT " . $start . ", " . $args['p_str']; 
		}

		$SQLCount = str_replace(array_keys($SQLConst), array_values($SQLConst), "SELECT COUNT(%select%) FROM forum_topics %join% WHERE 1=1 %where%"); 
		$this->total = db::count($SQLCount); 

		$this->pages = ceil($this->total / $this->args['p_str']); 

		$SQLSelect = str_replace(array_keys($SQLConst), array_values($SQLConst), "SELECT %select% FROM forum_topics %join% WHERE 1=1 %where% %order% %limit%"); 

		$this->request = $SQLSelect; 
		$items = db::select($SQLSelect); 
		$this->items = $items; 
	}

	public function is_posts() {
		if (count($this->items) > 0) {
			return true; 
		}
		return false; 
	}
}