<?php 

class Widget_Forum extends Widget
{
	public function __construct() {
		parent::__construct(array(
			'title' => __p('Форум: Новые темы', DS_FORUM), 
			'icon' => '<i class="fa fa-font" aria-hidden="true"></i>', 
		));
	}

	public function form($instance) 
	{
		?>
		<p><input type="text" name="count" placeholder="Колличество" value="<?php echo $this->get_field('count'); ?>" /></p>
		<?
	}

	public function widget($instance) {
		?>
		<div class="box-group-wrap">
			<div class="box-group">
				<div class="box-group-title"><a href="/forum/"><i class="fa fa-comments" aria-hidden="true"></i> <?php echo __p('Форум', DS_FORUM); ?></a></div>

				<div class="box-group-block">
				<?php 
				$args = array(
					'p_str' => $this->get_field('count'), 
					'orderby' => 'uptime', 
					'order' => 'DESC', 
				); 

				$query = new DB_Forum_Topics($args); 

				if ($query->is_posts()) {
					$template_list = use_filters('ds_forum_template_list_item', 
						'<div class="%class_list%"><a class="%class_list%-link" href="%link%">%icon% <span class="%class_list%-title">%title%</span><span class="list-item-counter" data-count-new="%counter_new%">%counter_all%</span></a></div>');
					$template_box = use_filters('ds_forum_template_list', '%content%'); 

					$content = ''; 
					foreach($query->items AS $post) 
					{
						$comment_table = use_filters('ds_comment_table', 'comments', 'forum', $post['id']); 
						$counters = db::fetch("SELECT COUNT(*) AS 'all', SUM(IF(time > '" . mktime(0,0,0) . "', 1, 0)) AS 'new' 
												FROM `" . $comment_table . "` 
												WHERE `object` = 'forum' AND `object_id` = '" . $post['id'] . "'"); 

						$mask_list = use_filters('ds_forum_mask_list_item', array(
						    '%class_list%' => 'list-item', 
						    '%counter_all%' => (int) $counters['all'], 
						    '%counter_new%' => (int) $counters['new'], 
							'%icon%' => get_forum_topic_icon($post['status']), 
						    '%title%' => text($post['title']), 
						    '%link%' => get_forum_topic_url($post), 
						)); 

						$content .= str_replace(array_keys($mask_list), array_values($mask_list), $template_list); 
					}
					
					echo str_replace('%content%', $content, $template_box); 
				} else {
					echo __p('Темы для обсуждения не найдены', DS_FORUM); 
				}
				?>
				</div>		
			</div>
		</div>
		<?
	}
}

register_widget('Widget_Forum'); 