<?php 

function ds_forum_breadcrumb($forum_id, $last = false, $mask = array(), $delim = ' / ') 
{
	$bread = array(); 
	$bread[] = '<i class="fa fa-weixin" aria-hidden="true"></i> <a href="' . get_site_url('/forum/') . '">' . __p('Форум', DS_FORUM) . '</a>'; 



	echo '<div class="breadcrumb">' . join($delim, $bread) . '</div>'; 
}

function get_forum_url($forum_id) 
{
	$forum = get_forum($forum_id); 
	$url = get_site_url('/forum/'); 

	if (isset($forum['id'])) {
		$url = get_site_url('/forum/' . urlencode($forum['slug']) . '/'); 
	}
	
	return $url; 
}

function get_forum($slug)
{
	$all_forums = ds_get('ds_forums', array()); 

	if (isset($all_forums[$slug])) {
		return $all_forums[$slug]; 
	}

	if (is_numeric($slug)) {
		$forum = db::fetch("SELECT * FROM forum WHERE id = '" . (int) $slug . "' LIMIT 1"); 
	} else {
		$forum = db::fetch("SELECT * FROM forum WHERE slug = '" . db::esc($slug) . "' LIMIT 1"); 

		if (isset($forum['id'])) {
			$all_forums[$forum['id']] = $forum; 
		}
	}

	$all_forums[$slug] = $forum; 
	
	return $forum; 
}

function get_forum_topic($topic_id) 
{
	$topic = db::fetch("SELECT * FROM forum_topics WHERE id = '" . db::esc($topic_id) . "' LIMIT 1"); 
	return $topic; 
}

function get_forum_topic_url($topic, $get = array()) {
	if (is_numeric($topic)) {
		$topic = get_forum_topic($topic); 
	}

	$url = '/forum/'; 
	if (isset($topic['id'])) {
		$forum = get_forum($topic['forum_id']); 
		$url = get_site_url('/forum/' . urlencode($forum['slug']) . '/' . $topic['id'] . '/'); 

		if ($get) {
			$url = get_query_url($get, $url); 
		}
	}

	return $url;
}

function get_forum_topic_icon($status = 'open') 
{
	$icon = ''; 
	if ($status == 'open') {
		$icon = '<i class="fa fa-file-text-o ft-open" aria-hidden="true"></i>'; 
	}

	return use_filters('ds_forum_topic_icon', $icon, $status); 
}

function get_forum_child($forum_id = 0) 
{
	$result = db::select("SELECT * FROM forum WHERE parent_id = '" . $forum_id . "' ORDER BY id DESC"); 
	return $result; 
}

function gen_forum_slug($slug = '', $forum_id = 0) 
{
    $slug = retranslit($slug);  

    $forum = db::fetch("SELECT * FROM forum WHERE slug = '" . db::esc($slug) . "' AND id != '" . $forum_id . "' LIMIT 1"); 

    if (isset($forum['id'])) {
    	$i = 1; 
    	while(true) {
    		$i++; 
    		$generate_slug = $slug . '-' . $i; 
    		$forum = db::fetch("SELECT * FROM forum WHERE slug = '" . db::esc($generate_slug) . "' AND id != '" . $forum_id . "' LIMIT 1"); 

    		if (!isset($forum['id'])) {
    			$slug = $generate_slug; 
    			break; 
    		}
    	}
    }

    return $slug; 
}

function get_forum_childs($slug) {
	$parent = get_forum($slug); 
	$childs = db::select("SELECT * FROM `forum` WHERE `path` like '%/" . $parent['slug'] . "/%'"); 

	return $childs ? $childs : array(); 
}

function get_forum_count_topics($slug) 
{
	$parent = get_forum($slug); 
	$forums = get_forum_childs($slug); 

	$ids = array(); 
	foreach($forums AS $forum) {
		array_push($ids, $forum['id']); 
	}
	array_push($ids, $parent['id']); 

	$count = db::count("SELECT COUNT(*) FROM forum_topics WHERE forum_id IN(" . join(',', $ids) . ")"); 

	return $count; 
}

function ds_forum_topic_remove($topic_id) 
{
	$topic = get_forum_topic($topic_id); 

	do_event('ds_forum_topic_delete', $topic); 

	db::query("DELETE FROM `forum_comments` WHERE `object_id` = '" . $topic['id'] . "'"); 
	db::query("DELETE FROM `forum_topics` WHERE `id` = '" . $topic['id'] . "' LIMIT 1"); 

	do_event('ds_forum_topic_deleted', $topic); 
}