<?php 

if (!defined('DS_FORUM')) {
	die(); 
}

if (!isset($forum['id'])) {
	$forum['type'] = 'forums'; 
}

$set['title'] = __p('Форум', DS_FORUM); 
get_header(); 

$default = array(
	'%class%' => '', 
	'%link%' => '', 
	'%title%' => '', 
	'%before%' => '', 
	'%after%' => '', 
); 

$mask = array(); 

ds_forum_breadcrumb($forum_id); 

$default = use_filters('ds_forum_action_add_default', $default); 

$action_add = array(); 

if (is_user() && isset($forum['id']) && $forum['type'] == 'topics') {
	$action_add['create'] = array(
		'%link%' => get_site_url('/forum/?p=' . $forum_id . '&action=create'), 
		'%title%' => __p('Новая тема', DS_FORUM), 
		'%icon%' => get_icon_html('fa-plus'), 
	); 	
}

$action_add = use_filters('ds_forum_action_add', $action_add); 

if (count($action_add) > 0) {
	$template_link = use_filters('ds_forum_template_add_item', '%before%<a class="%class%" href="%link%">%icon%%title%</a>%after%'); 
	$template_box = use_filters('ds_forum_template_add_box', '<div class="ds-actions ds-actions-%count%">%items%</div>'); 

	$action_items = array(); 
	foreach($action_add AS $key => $value) {
		$value = array_merge($default, $value); 
		$action_items[] = str_replace(array_keys($value), array_values($value), $template_link); 
	}

	if (!empty($action_items)) {
		echo str_replace(array(
			'%count%', 
			'%items%', 
		), array(
			count($action_items), 
			join('', $action_items), 
		), $template_box); 
	}
}

$forums = get_forum_child($forum_id); 
$template_list = use_filters('ds_forum_template_list_item', '<div class="%class_list%"><a class="%class_list%-link" href="%link%">%icon% <span class="%class_list%-title">%title%</span> <span class="%class_list%-counter">%counter%</span></a></div>');

if ($forum['type'] == 'forums') {
	if (count($forums) > 0) {
		echo '<div class="list list-forums">'; 

		foreach($forums AS $child) {
			$mask_link = array_merge($mask, array(
			    '%slug%' => $child['slug'], 
			));
			
			$mask_item = use_filters('ds_forum_mask_list_item', array_merge($mask, array(
			    '%action%' => $action, 
			    '%class_list%' => 'list-item', 
			    '%counter%' => get_forum_count_topics($child['slug']), 
			    '%icon%' => '<i class="fa fa-comments" aria-hidden="true"></i>', 
			    '%title%' => text($child['title']), 
			    '%link%' => str_replace(array_keys($mask_link), array_values($mask_link), $permalinks['forum']), 
			))); 
			
			echo str_replace(array_keys($mask_item), array_values($mask_item), $template_list); 
		}	

		echo '</div>'; 		
	} else {
		echo '<div class="list-empty">' . __p('Разделы не созданы', DS_FORUM) . '</div>'; 
	}	
}

if ($forum['type'] == 'topics') {
	
	$args = array(
		'forum_id' => $forum_id, 
	); 

	$query = new DB_Forum_Topics($args); 

	if ($query->is_posts()) {

		$template_list = use_filters('ds_forum_template_list_item', 
			'<div class="%class_list%"><a class="%class_list%-link" href="%link%">%icon% <span class="%class_list%-title">%title%</span><span class="list-item-counter" data-count-new="%counter_new%">%counter_all%</span></a></div>');
		$template_box = use_filters('ds_forum_template_list', '<div class="list list-forum">%content%</div>'); 

		$content = ''; 
		foreach($query->items AS $post) 
		{
			$comment_table = use_filters('ds_comment_table', 'comments', 'forum', $post['id']); 
			$counters = db::fetch("SELECT COUNT(*) AS 'all', SUM(IF(time > '" . mktime(0,0,0) . "', 1, 0)) AS 'new' 
									FROM `" . $comment_table . "` 
									WHERE `object` = 'forum' AND `object_id` = '" . $post['id'] . "'"); 

			$mask_list = use_filters('ds_forum_mask_list_item', array(
			    '%class_list%' => 'list-item', 
			    '%counter_all%' => (int) $counters['all'], 
			    '%counter_new%' => (int) $counters['new'], 
				'%icon%' => get_forum_topic_icon($post['status']), 
			    '%title%' => text($post['title']), 
			    '%link%' => get_forum_topic_url($post), 
			)); 

			$content .= str_replace(array_keys($mask_list), array_values($mask_list), $template_list); 
		}
		
		echo str_replace('%content%', $content, $template_box); 

		if ( $query->pages > 1 ) {
		    str('?', $query->pages, $query->paged);
		}
	} else {
		echo '<div class="list-empty">' . __p('Разделы не созданы', DS_FORUM) . '</div>'; 
	}	
}


get_footer(); 