<?php 

if (!defined('DS_FORUM')) {
	die(); 
}

$mask = array(); 

$parent_id = (isset($_GET['p']) ? (int) $_GET['p'] : 0);
$parent = get_forum($parent_id); 

if (!isset($parent['id'])) {
	ds_die(__p('Раздел не найден', $plug)); 
}

if (isset($_POST['title'])) {
	if (strlen2($_POST['title']) < 2) {
		add_error(__p('Слишком короткое название', $plug)); 
	}
	
	if (strlen2($_POST['title']) > 128) {
		add_error(__p('Слишком длинное название', $plug)); 
	}
	
	if (strlen2($_POST['msg']) < 2) {
		add_error(__p('Текст темы слишком короткий', $plug)); 
	}
	
	if (!is_errors()) {

		$res = db::insert('forum_topics', array(
			'title' => $_POST['title'], 
			'msg' => $_POST['msg'], 
			'forum_id' => $parent['id'], 
			'datetime' => date('Y-m-d H:i:s'), 
			'user_id' => get_user_id(), 
		)); 

		$_SESSION['message'] = __p('Тема успешно создана', $plug);  
		ds_redirect(get_forum_url($parent_id)); 
	}
}

$set['title'] = __p('Форум - Новая тема', $plug); 
get_header(); 

// Хлебные крошки 
ds_forum_breadcrumb($forum_id, true, $mask);

$fields = array(
	array(
		'field_name' => 'title', 
		'field_type' => 'text', 
		'field_title' => __p('Название темы', $plug), 
	), 
	array(
		'field_name' => 'msg', 
		'field_type' => 'editor', 
		'field_title' => __p('Описание', $plug), 
	),  
	array(
		'field_name' => 'save', 
		'field_type' => 'submit', 
		'field_title' => __p('Создать', $plug), 
		'field_class' => 'button', 
	), 
); 

$fields = use_filters('ds_forum_create_terms_fields', $fields); 

$form = new Forms(text($_SERVER['REQUEST_URI']), 'POST'); 
foreach($fields AS $field) {
	$form->add_field($field); 
}
echo $form->display(); 

get_footer(); 