<?php 

if (!defined('DS_FORUM')) {
	die(); 
}

if (!isset($topic['id'])) {
	ds_die(__p('Тема не найдена', $plug)); 
}

$mask = array(); 

if (isset($_POST['title'])) {
	if (strlen2($_POST['title']) < 2) {
		add_error(__p('Слишком короткое название', $plug)); 
	}
	
	if (strlen2($_POST['title']) > 128) {
		add_error(__p('Слишком длинное название', $plug)); 
	}
	
	if (strlen2($_POST['msg']) < 2) {
		add_error(__p('Текст темы слишком короткий', $plug)); 
	}
	
	if ($topic['user_id'] != $user['id']) {
		add_error(__p('У вас нет доступа', $plug)); 
	}

	if (!is_errors()) {
		$res = db::update('forum_topics', array(
			'title' => $_POST['title'], 
			'msg' => $_POST['msg'], 
		), array(
			'id' => $topic['id'], 
		)); 

		$_SESSION['message'] = __p('Изменения успешно приняты', $plug);  
		ds_redirect(get_forum_topic_url($topic)); 
	}
}

$set['title'] = __p('Форум - Новая тема', $plug); 
get_header(); 

// Хлебные крошки 
ds_forum_breadcrumb($forum_id, true, $mask);

$fields = array(
	array(
		'field_name' => 'title', 
		'field_type' => 'text', 
		'field_title' => __p('Название темы', $plug), 
		'field_value' => text($topic['title']), 
	), 
	array(
		'field_name' => 'msg', 
		'field_type' => 'editor', 
		'field_title' => __p('Описание', $plug), 
		'field_value' => text($topic['msg']), 
	),  
	array(
		'field_name' => 'save', 
		'field_type' => 'submit', 
		'field_title' => __p('Сохранить', $plug), 
		'field_class' => 'button', 
	), 
); 

$fields = use_filters('ds_forum_edit_terms_fields', $fields); 

$form = new Forms(text($_SERVER['REQUEST_URI']), 'POST'); 
foreach($fields AS $field) {
	$form->add_field($field); 
}
echo $form->display(); 

get_footer(); 