<?php 

if (!defined('DS_FORUM')) {
	die(); 
}

if (!isset($topic['id'])) {
	ds_die(__p('Тема не найдена', $plug)); 
}

$mask = array(); 

$set['title'] = text($topic['title']); 
get_header(); 

// Хлебные крошки 
ds_forum_breadcrumb($forum_id, true, $mask);

?>
<div class="box-group-wrap">
	<div class="box-group">
		<div class="box-group-title"><?php echo get_forum_topic_icon($topic['status']); ?> <?php echo text($topic['title']); ?></div>

		<div class="post-header">
			<div class="post-header-image"><?php echo get_avatar($topic['user_id']); ?></div>
			<div class="post-header-content">
				<div class="post_title">
					<a href="<?php echo get_user_url($topic['user_id']); ?>"><?php echo get_user_nick($topic['user_id']); ?></a>
				</div>
				<div class="post_content">
					<?php echo ds_date('d F Y H:i', strtotime($topic['datetime'])); ?>
				</div>
			</div>
		</div>

		<div class="box-group-block"><?php echo output_text($topic['msg']); ?></div>
	</div>

	<?php if (is_user() && $topic['user_id'] == $user['id']) : ?>
	<div class="box-group">
		<div class="box-group-links box-group-center">
			<a class="box-link" href="<?php echo get_forum_topic_url($topic, array('action' => 'edit')); ?>" title="Редактировать"><i class="fa fa-edit"></i> <?php echo __p('Редактировать', $plug); ?></a>
			<a class="box-link" href="<?php echo get_forum_topic_url($topic, array('action' => 'remove')); ?>" title="Удалить"><i class="fa fa-trash"></i> <?php echo __p('Удалить', $plug); ?></a>
		</div>
	</div>
	<?php endif; ?>

	<div class="box-group" data-group="comments">
		<div class="box-group-title">
		<?php 
		$hash = get_comments_hash('forum', $topic['id']); 
		$count = get_comments_count('forum', $topic['id']); 
		echo use_filters('ds_comments_box_title', __p('Комментарии: %s', $plug, '<span data-comments-count="' . $hash . '">' . $count . '</span>'), $hash, 'forum', $topic['id']); 
		?>
		</div>

		<?php if (is_user()) : ?>
		<div class="box-group-block" data-block="comments-form">
		<?php 
		ds_message('forum', array(
			'type' => 'comment',  
			'object' => 'forum', 
			'object_id' => $topic['id'],  
			'comments_title' => 'Тема форума / ' . $topic['title'], 
		)); 
		?>
		</div>
		<?php endif; ?>

		<div class="box-group-block" data-block="comments-list">
		<?
		$comments = new DB_Comments(array(
			'db_table' => 'forum_comments', 
			'object' => 'forum', 
			'object_id' => $topic['id'],  
		)); 

		$last = array_key_first($comments->items);
		$first = array_key_last($comments->items); 
		$last_id = (!empty($comments->items[$last]) ? $comments->items[$last]['id'] : -1); 
		$first_id = (!empty($comments->items[$first]) ? $comments->items[$first]['id'] : -1); 

		echo '<div class="ds-comments" id="ds-comments" data-paged="' . $comments->paged . '" data-last="' . $last_id . '" data-first="' . $first_id . '" data-comments="' . $hash . '">'; 
		if ($comments->is_posts()) {
			foreach($comments->items() AS $post) {
		        $classes = array(
		            'ds-messages-item', 
		            'comment comment-' . $post['id'], 
		        ); 

		        $args = array(
		        	'classes' => join(' ', $classes), 
		        	'image' => get_avatar($post['user_id']), 
		        	'title' => '<a href="' . get_user_url($post['user_id']) . '">' . get_user_nick($post['user_id']) . '</a>', 
		        	'time' => vremja($post['time']), 
		        	'content' => output_text($post['msg']), 
		        	'reply' => '?reply_to=' . $post['user_id'] . '&comment_id=' . $post['id'], 
		        	'actions' => array(), 
		        ); 

		        if (is_user() && get_user_id() != $post['user_id']) {
		        	$args['actions'][] = use_filters('ds_comment_link_reply', array(
	        			'url' => get_forum_topic_url($topic, array(
	        				'reply' => $post['id'], 
	        				'user_id' => $post['user_id'], 
	        			)), 
	        			'title' => __p('Ответ', $plug), 
		        	), $post);
		        }

		        if (is_user_access('forum_post_ed')) {
		        	$args['actions'][] = array(
	        			'url' => get_forum_topic_url($topic, array(
	        				'cmt' => 'forum', 
	        				'cma' => 'remove', 
	        				'cmu' => $post['id'], 
	        			)), 
	        			'title' => __p('Удалить', $plug), 
		        	); 
		        }

		        echo get_comment_template($args); 
			}
		} else {
			echo '<div class="comments-empty">' . __p('Список комментариев пуст', $plug) . '</div>'; 
		}
		echo '</div>'; 

		if ( $comments->pages > 1 ) {
		    str('?', $comments->pages, $comments->paged);
		}
		?>
		</div>
	</div>
</div>

<?

get_footer(); 